# 2d Designer

Mit diesem Plugin geben sie ihren Online-Kunden die M&#xF6;glichkeit ausgew&#xE4;hlte Artikel nach eigenen Vorstellungen zu gestalten. Dies erfolgt in einem intuitiv benutzbaren Editor direkt in der Artikelansicht in ihrem Online-Shop.

Dabei kommen die ganz normalen Artikelbilder als Masken zum Einsatz. Mit Hilfe dieser Masken k&#xF6;nnen sie den gestaltbaren Bereich f&#xFC;r einen Artikel bestimmen. Durch den Einsatz von zwei Masken, jeweils f&#xFC;r Hintergrund und Vordergrund, ist es leicht m&#xF6;glich Aussparungen, etwa f&#xFC;r Brusttaschen bei Hemden, im gestaltbaren Bereich umzusetzen. Der gestaltbare Bereich liegt dann im Editor zwischen diesen beiden Masken.

Sie haben die M&#xF6;glichkeit Standardelemente, die ihre Kunden zur Gestaltung heranziehen k&#xF6;nnen, nach eigenen Vorstellungen anzulegen und zu gruppieren. F&#xFC;r Texte k&#xF6;nnen sie die verf&#xFC;gbaren Schriftarten festlegen.

Gestaltungen zu Bestellungen k&#xF6;nnen &#xFC;ber den Admin-Bereich des Plugins im Shop heruntergeladen werden. Optional k&#xF6;nnen diese Dateien auch &#xFC;ber die WAWI heruntergeladen werden, wenn das JTL-Upload-Modul f&#xFC;r den Shop lizensiert ist.

## Voraussetzungen WAWI

### Artikelbilder als Designer-Masken

- es werden die ersten beiden Artikelbilder als Masken f&#xFC;r den Designer verwendet. Die tats&#xE4;chliche Anzahl wird mit u.g. Funktionsattribut eingestellt
- optional ist ein drittes Bild als Vorschaubild m&#xF6;glich. Ein Artikel h&#xE4;tte dann in der Reihenfolge von oben nach unten die folgenden Bilder: 1. Vorschaubild, 2. Hintergrund f&#xFC;r Designer, 3. Transparenzmaske f&#xFC;r Designer, 4. optionaler Hintergrund f&#xFC;r die R&#xFC;ckseite, 5. optionale Transparenzmaske f&#xFC;r die R&#xFC;ckseite
- die Bilder sollten in der WAWI im PNG-Format eingestellt werden, damit Transparenzen in den Masken realisiert werden k&#xF6;nnen
- die Gr&#xF6;&#xDF;e der Bilder sollte zwischen 800 und 1000 Pixeln liegen. Hier m&#xFC;ssen sie ggf. experimentieren, um die passende Gr&#xF6;&#xDF;e f&#xFC;r ihr Template zu finden
- speichern Sie die Bilder als RGB oder Truecolor ab!

### Funktionsattribute

| Attributname             | Attributwert         | Standardwert  | Beschreibung                                                                |
|--------------------------|----------------------|---------------|-----------------------------------------------------------------------------|
| 2dCanvasEnable           | 0, 1                 | 1             | gibt an, ob der Artikel gestaltet werden kann                               |
| 2dCanvasLayers           | 1, 2                 | 1             | Anzahl der Maskenebenen                                                     |
| 2dCanvasLeft             | 270                  | keiner        | Position von links in Pixeln, relativ zum Maskenbild                        |
| 2dCanvasTop              | 118                  | keiner        | Position von oben in Pixeln, relativ zum Maskenbild                         |
| 2dCanvasWidth            | 261                  | Bildbreite    | Breite des Zeichenbereichs in Pixeln, bezogen auf Maskenbild                |
| 2dCanvasHeight           | 567                  | Bildh&#xF6;he | H&#xF6;he des Zeichenbereichs in Pixeln, bezogen auf Maskenbild             |
| 2dCanvasPrintDPI         | 200                  | 96            | Druckaufl&#xF6;sung in DPI, die f&#xFC;r diesen Artikel verwendet wird      |
| 2dCanvasModules          | upl,mot,txt          |               | Gestaltungsmodule. &#xDC;berschreibt globale Einstellung                    |
| 2dCanvasMotiveCategories | kommagetrennte Liste |               | Kann verwendet werden, um die Motive pro Artikel zu steuern, Freitext       |
| 2dCanvasgreyscale        | 0, 1                 | keiner        | Checkbox, gibt an, ob hochgeladene Bilder eingef&auml;rbt werden sollen     |
| 2dCanvasgreyscalecolor   | HEX Farbcode         | #999999       | Farbe, mit der ein hochgeladenes Bild eingef&auml;rbt werden soll           |
| 2dCanvasTextCurvature    | 0, 1                 | keiner        | erlaubt Textkrümmung per Artikel, optional, Checkbox                        |
| 2dCanvasFonts            | kommagetrennte Liste | keiner        | Kann verwendet werden, um die Schriftarten pro Artikel zu steuern, Freitext |

### Variation

Um eine dauerhafte Referenz auf die Gestaltung zu erhalten, verwendet das Plugin eine Pflichtfreitext-Variation mit dem Namen "eigene Gestaltung". Diese Variation muss f&#xFC;r jeden gestaltbaren Artikel angelegt sein.

#### CSV Beispiel-Datei der Attribute zum Ameisenimport in die WAWI

```csv
"Artikelnummer";"Artikelname";"Interner Schluessel";"EAN/Barcode";"HAN";"Serie";"Attributgruppe";"Attributname";"Attributwert";"Sortiernummer";"Attributtyp";"Attribut / Funktionsattribut";"2d Designer Deutsch: Attributwert";
"1";"Smartphone Cover";"44963";"4674684618";;;;"2dCanvasEnable";"1";;;"Funktionsattribut";;
"1";"Smartphone Cover";"44963";"4674684618";;;;"2dCanvasLayers";"2";;;"Funktionsattribut";;
"1";"Smartphone Cover";"44963";"4674684618";;;;"2dCanvasLeft";"270";;;"Funktionsattribut";;
"1";"Smartphone Cover";"44963";"4674684618";;;;"2dCanvasTop";"118";;;"Funktionsattribut";;
"1";"Smartphone Cover";"44963";"4674684618";;;;"2dCanvasWidth";"261";;;"Funktionsattribut";;
"1";"Smartphone Cover";"44963";"4674684618";;;;"2dCanvasHeight";"567";;;"Funktionsattribut";;
"1";"Smartphone Cover";"44963";"4674684618";;;;"2dCanvasPrintDPI";"200";;;"Funktionsattribut";;
"1";"Smartphone Cover";"44963";"4674684618";;;;"2dCanvasModules";"upl,mot,txt";;;"Funktionsattribut";;
```

## Voraussetzungen Shop

- Stellen sie sicher, dass die PHP-Erweiterungen GD und Imagick aktiviert sind. GD sollte f&#xFC;r den Shop sowieso aktiviert sein, Imagick wird zum erstellen von Schriften ben&#xF6;tigt.
- Imagick und damit auch ImageMagic muss SVG unterst&#xFC;tzen. Bei manchen Distributionen ist diese in einem zus&#xE4;tzlichen Paket realisiert (libmagick...extra). Sehen sie in phpinfo unter imagick, ImageMagick supported formats nach, ob dort SVG mit aufgef&#xFC;hrt ist.
- Debian 8 verf&#xFC;gt &#xFC;ber eine veraltete und fehlerhafte Version von ImageMagick, die bei manchen Schriftarten verzerrte Ausgaben erzeugt.
- Wenn auf ihrem Shop-Server pngcrush installiert ist, so wird dies automatisch erkannt und zur Optimierung der Motive verwendet.
- Im Shop muss im Admin-Bereich im Men&#xFC; Storefront -> Bilder -> Einstellungen "PNG" als Dateityp f&#xFC;r Bilder eingestellt sein, damit Transparenzen in den Maskenbildern erhalten bleiben.
- Der 2d Designer ist in der Ausgangsversion auf das Evo-Template von JTL ausgelegt, l&#xE4;sst sich aber leicht auf &#xE4;hnliche Templates anpassen.

## Module

Im Backend k&#xF6;nnen die Module f&#xFC;r Bild-Upload, Motive und Text global aktiviert werden. Diese gelten dann f&#xFC;r alle Artikel, die den Designer verwenden.

&#xDC;ber das Funktionsattribut 2dCanvasModules kann dies auch pro Artikel erfolgen. Dabei gilt: ist das Attribut vorhanden, dann &#xFC;berschreibt es die globale Einstellung. Ist im Attribut ein Wert f&#xFC;r ein Modul enthalten, so wird dieses Modul aktiviert. Fehlt der Wert, dann wird es deaktivert.

| Modul         | Attributwert |
|---------------|:------------:|
| Bilder Upload |     upl      |
| Motive        |     mot      |
| Text          |     txt      |

## Zweiseitig gestaltbare Artikel

Soll ein Artikel, etwa ein T-Shirt, beidseitig gestaltbar sein, muss dem Artikel ein weiteres Funktiosattribut hinzugef&#xFC;gt werden:

> 2dCanvasFlipable 0,1

Ist dieses Attribut vorhanden und hat den Inhalt "1", dann gibt es automatisch einen doppelten Satz an Funktionsattributen, welche die Vorder- bzw. R&#xFC;ckseite steuern.


| Einfach          | Flipable                                    |
|------------------|---------------------------------------------|
| 2dCanvasLayers   | 2dCanvasLayersFront, 2dCanvasLayersBack     |
| 2dCanvasLeft     | 2dCanvasLeftFront, 2dCanvasLeftBack         |
| 2dCanvasTop      | 2dCanvasTopFront, 2dCanvasTopBack           |
| 2dCanvasWidth    | 2dCanvasWidthFront, 2dCanvasWidthBack       |
| 2dCanvasHeight   | 2dCanvasHeightFront, 2dCanvasHeightBack     |
| 2dCanvasPrintDPI | 2dCanvasPrintDPIFront, 2dCanvasPrintDPIBack |

- Die Attribute funktionieren genau so, wie bei einem einseitigen Artikel
- Eine eventuell vorhandenene artikelindividuelle Modulkonfiguration (2dCanvasModules) gillt immer f&#xFC;r beide Seiten eines Artikels gleich
- *Die normalen Attribute f&#xFC;r einseitige Artikel haben dann keine Wirkung mehr!*
- F&#xFC;r die Bilder der R&#xFC;ckseite gilt dann: 4. Bild ist der Hintergrund f&#xFC;r die R&#xFC;ckseite, 5. Bild ist die Transparenzmaske f&#xFC;r die R&#xFC;ckseite

## Artikelspezifische Farben für Text

&Uuml;ber ein Funktionsattribut kann pro Artikel die Auswahl an verf&uuml;gbaren Farben festgelegt werden. Hat ein
Artikel dieses Attribut, stehen nur noch die hier hinterlegten Farben f&uuml;r Umriss und F&uuml;llung zur Verf&uuml;gung,
unabh&auml;ngig davon, ob im Backend Farben angelegt sind, oder ob dort die
Einstellung &quot;Nur definierte Farben&quot; gew&auml;hlt wurde.

Das Funktionsattribut hei&szlig;t &quot;2dCanvasForcedColors&quot;, ist vom Typ Freitext und hat JSON als Fomat.
Das Feld "name" ist optional und kann farbindividuell eingesetzt werden.
```javascript
[
  {
    "color": "#000000",
    "stroke": "1",
    "fill": "1",
    "name": "Schwarz"
  },
  {
    "color": "#34bbe6",
    "stroke": "1",
    "fill": "1"
  }
]
```
Pro Farbe ist ein Eintrag in der folgenden Form n&ouml;tig:
```json
{
  "color": "#34bbe6",
  "stroke": "1",
  "fill": "1"
}
```
Dabei definiert &quot;color&quot; die Farbe als HTML Hexcode, &quot;stroke&quot; und &quot;fill&quot; weisen die Farbe
den Auswahlfeldern f&uuml;r Umriss (stroke) und F&uuml;llung (fill) zu. Stroke und fill können die
Werte 0 und 1 annehmen, wobei eine 1 der Zuweisung entspricht. Zusätzlich kann ein Feld "name" angegeben werden, dessen
Inhalt als Tooltip der Farbauswahlfläche verwendet wird.


## Eigene Schriftarten

Sie k&ouml;nnen zus&auml;tzlich zu den von Google beziehbaren Schriftarten eigene Schriftarten hinterlegen. Bitte beachten sie aber, dass
sie vom Hersteller oder Lizenzgeber die Erlaubnis haben, diese Schriftarten im Internet zu ver&ouml;ffentlichen.

Schriftarten werden in Form einer ZIP-Datei pro Schriftart im Backend hinterlegt. Diese ZIP-Datei erhalten sie von
FontSquirrel unter der URL [FontSquirrel](https://www.fontsquirrel.com/tools/webfont-generator).

W&auml;hlen sie dort die Expert-Option aus und aktivieren sie zus&auml;tzlich das Font-Format &quot;TrueType&quot;.

Die so erzeugte ZIP-Datei kann vom 2D Designer Plugin verarbeitet werden.


## Staffelpreise für Text und Motive/Bilder

Das JTL-Konfigurator-Modul kann verwendet werden, um Aufpreise für Gestaltungselemente zu realisieren.

Dazu m&uuml;ssen in der WAWI entsprechende Konfigurationgruppen mit den folgenden Name angelegt werden:

1. 2dCanvasExtraChargeMotives
2. 2dCanvasExtraChargeTexts

Beide Gruppen sind vom Typ &quot;selectbox&quot; und haben eine Mindestmenge von 0.
Die Komponenten haben ein Minimum von 1 und ein Maximum, welches sie auf einen vern&uuml;nftigen Wert festlegen k&ouml;nnen.

Nun legen sie ein weitere FunktionsAttribut mit dem Name &quot;2dCanvasDontShow&quot; mit dem Typ Checkbox an. Dieses wird
verwendet, um die Konfigurationskomponenten-Artikel aus dem Shop auszublenden.

Nun legen sie f&uuml;r Motive und Texte entsprechende Artikel mit den passenden Aufpreisen an. Diesen Artikeln
weisen sie das FunktionsAttribut zu und f&uuml;gen sie zur Konfigurationsgruppe hinzu.

Wenn sie nun einem gestalbaren Artikel diese Konfigurationsgruppe zuweisen, wird die Menge
der einzelnen Komponenten vom Plugin ferngesteuert und so sicher gestellt, dass die Aufpreise
f&uuml;r Motive und Texte korrekt angezeigt und berechnet werden.

M&ouml;chten sie Texte und Motive erst ab einer bestimmten Menge berechnen, dann k&ouml;nnen sie die Funktionsattribute
**&quot;2dCanvasFreeText&quot;** und **&quot;2dCanvasFreeMotive&quot;**, beides Ganzzahlen, verwenden, um festzulegen ab
wie vielen Objekten Aufpreise f&auml;llig werden.
